<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=11"/>
<meta name="generator" content="Doxygen 1.9.3"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>NANO102/112 BSP: StdDriver/src/timer.c Source File</title>
<link href="../../tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../jquery.js"></script>
<script type="text/javascript" src="../../dynsections.js"></script>
<link href="../../doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr id="projectrow">
  <td id="projectlogo"><img alt="Logo" src="../../M0Banner_v2.jpg"/></td>
  <td id="projectalign">
   <div id="projectname">NANO102/112 BSP<span id="projectnumber">&#160;V3.04.000</span>
   </div>
   <div id="projectbrief">The Board Support Package for Nano102/112 Series</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.3 -->
<script type="text/javascript" src="../../menudata.js"></script>
<script type="text/javascript" src="../../menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() {
  initMenu('../../',false,false,'search.php','Search');
});
/* @license-end */
</script>
<div id="main-nav"></div>
<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="../../dir_0d398eaf8b2db165a9197a6619ec9f0e.html">StdDriver</a></li><li class="navelem"><a class="el" href="../../dir_3abedc03644d33bc69016fb8a5546004.html">src</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle"><div class="title">timer.c</div></div>
</div><!--header-->
<div class="contents">
<a href="../../df/d41/timer_8c.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a id="l00001" name="l00001"></a><span class="lineno">    1</span><span class="comment">/**************************************************************************/</span></div>
<div class="line"><a id="l00012" name="l00012"></a><span class="lineno">   12</span><span class="preprocessor">#include &quot;<a class="code" href="../../da/d91/_nano1_x2_series_8h.html">Nano1X2Series.h</a>&quot;</span></div>
<div class="line"><a id="l00013" name="l00013"></a><span class="lineno">   13</span> </div>
<div class="line"><a id="l00042" name="l00042"></a><span class="lineno"><a class="line" href="../../d4/d07/group___n_a_n_o1_x2___t_i_m_e_r___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga234d45c63fb6f5e977dbef2294089621">   42</a></span>uint32_t <a class="code hl_function" href="../../d4/d07/group___n_a_n_o1_x2___t_i_m_e_r___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga234d45c63fb6f5e977dbef2294089621">TIMER_Open</a>(<a class="code hl_struct" href="../../d9/d66/struct_t_i_m_e_r___t.html">TIMER_T</a> *timer, uint32_t u32Mode, uint32_t u32Freq)</div>
<div class="line"><a id="l00043" name="l00043"></a><span class="lineno">   43</span>{</div>
<div class="line"><a id="l00044" name="l00044"></a><span class="lineno">   44</span>    uint32_t u32Clk = <a class="code hl_function" href="../../d4/d07/group___n_a_n_o1_x2___t_i_m_e_r___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga56facc5683886f3ff3b273a3b5e47fcd">TIMER_GetModuleClock</a>(timer);</div>
<div class="line"><a id="l00045" name="l00045"></a><span class="lineno">   45</span>    uint32_t u32Cmpr = 0, u32Prescale = 0;</div>
<div class="line"><a id="l00046" name="l00046"></a><span class="lineno">   46</span> </div>
<div class="line"><a id="l00047" name="l00047"></a><span class="lineno">   47</span>    <span class="comment">// Fastest possible timer working freq is u32Clk / 2. While cmpr = 2, pre-scale = 0</span></div>
<div class="line"><a id="l00048" name="l00048"></a><span class="lineno">   48</span>    <span class="keywordflow">if</span>(u32Freq &gt; (u32Clk / 2))</div>
<div class="line"><a id="l00049" name="l00049"></a><span class="lineno">   49</span>    {</div>
<div class="line"><a id="l00050" name="l00050"></a><span class="lineno">   50</span>        u32Cmpr = 2;</div>
<div class="line"><a id="l00051" name="l00051"></a><span class="lineno">   51</span>    }</div>
<div class="line"><a id="l00052" name="l00052"></a><span class="lineno">   52</span>    <span class="keywordflow">else</span></div>
<div class="line"><a id="l00053" name="l00053"></a><span class="lineno">   53</span>    {</div>
<div class="line"><a id="l00054" name="l00054"></a><span class="lineno">   54</span>        <span class="keywordflow">if</span>(u32Clk &gt; 0xFFFFFF)   <span class="comment">// For Nano1x2, only needs to consider 32MHz at most</span></div>
<div class="line"><a id="l00055" name="l00055"></a><span class="lineno">   55</span>        {</div>
<div class="line"><a id="l00056" name="l00056"></a><span class="lineno">   56</span>            u32Prescale = 1;</div>
<div class="line"><a id="l00057" name="l00057"></a><span class="lineno">   57</span>            u32Clk &gt;&gt;= 1;</div>
<div class="line"><a id="l00058" name="l00058"></a><span class="lineno">   58</span>        }</div>
<div class="line"><a id="l00059" name="l00059"></a><span class="lineno">   59</span>        u32Cmpr = u32Clk / u32Freq;</div>
<div class="line"><a id="l00060" name="l00060"></a><span class="lineno">   60</span>    }</div>
<div class="line"><a id="l00061" name="l00061"></a><span class="lineno">   61</span>    timer-&gt;<a class="code hl_variable" href="../../d4/d75/group___n_a_n_o1_x2__legacy___constants.html#ga91eb63011da0934d7d8edcfb58566417">CMPR</a> = u32Cmpr;</div>
<div class="line"><a id="l00062" name="l00062"></a><span class="lineno">   62</span>    timer-&gt;<a class="code hl_variable" href="../../d4/d75/group___n_a_n_o1_x2__legacy___constants.html#ga6a66d55fb7d20c3e12402aa320661d8f">PRECNT</a> = u32Prescale;</div>
<div class="line"><a id="l00063" name="l00063"></a><span class="lineno">   63</span>    timer-&gt;<a class="code hl_variable" href="../../d4/d75/group___n_a_n_o1_x2__legacy___constants.html#gabb8d9df4695b742a04b52a7a64594322">CTL</a> = u32Mode;</div>
<div class="line"><a id="l00064" name="l00064"></a><span class="lineno">   64</span> </div>
<div class="line"><a id="l00065" name="l00065"></a><span class="lineno">   65</span> </div>
<div class="line"><a id="l00066" name="l00066"></a><span class="lineno">   66</span>    <span class="keywordflow">return</span>(u32Clk / (u32Cmpr * (u32Prescale + 1)));</div>
<div class="line"><a id="l00067" name="l00067"></a><span class="lineno">   67</span>}</div>
<div class="line"><a id="l00068" name="l00068"></a><span class="lineno">   68</span> </div>
<div class="line"><a id="l00074" name="l00074"></a><span class="lineno"><a class="line" href="../../d4/d07/group___n_a_n_o1_x2___t_i_m_e_r___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga83113a85eb313523f4ec35ab585d8968">   74</a></span><span class="keywordtype">void</span> <a class="code hl_function" href="../../d4/d07/group___n_a_n_o1_x2___t_i_m_e_r___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga83113a85eb313523f4ec35ab585d8968">TIMER_Close</a>(<a class="code hl_struct" href="../../d9/d66/struct_t_i_m_e_r___t.html">TIMER_T</a> *timer)</div>
<div class="line"><a id="l00075" name="l00075"></a><span class="lineno">   75</span>{</div>
<div class="line"><a id="l00076" name="l00076"></a><span class="lineno">   76</span>    timer-&gt;<a class="code hl_variable" href="../../d4/d75/group___n_a_n_o1_x2__legacy___constants.html#gabb8d9df4695b742a04b52a7a64594322">CTL</a> = 0;</div>
<div class="line"><a id="l00077" name="l00077"></a><span class="lineno">   77</span>    timer-&gt;<a class="code hl_variable" href="../../d4/d75/group___n_a_n_o1_x2__legacy___constants.html#ga1b93de0ad6cd08676926bcff6888c10d">IER</a> = 0;</div>
<div class="line"><a id="l00078" name="l00078"></a><span class="lineno">   78</span>}</div>
<div class="line"><a id="l00079" name="l00079"></a><span class="lineno">   79</span> </div>
<div class="line"><a id="l00088" name="l00088"></a><span class="lineno"><a class="line" href="../../d4/d07/group___n_a_n_o1_x2___t_i_m_e_r___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga0dad1dbaf69f945c3d0d5aa91c4eef86">   88</a></span><span class="keywordtype">void</span> <a class="code hl_function" href="../../d4/d07/group___n_a_n_o1_x2___t_i_m_e_r___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga0dad1dbaf69f945c3d0d5aa91c4eef86">TIMER_Delay</a>(<a class="code hl_struct" href="../../d9/d66/struct_t_i_m_e_r___t.html">TIMER_T</a> *timer, uint32_t u32Usec)</div>
<div class="line"><a id="l00089" name="l00089"></a><span class="lineno">   89</span>{</div>
<div class="line"><a id="l00090" name="l00090"></a><span class="lineno">   90</span>    uint32_t u32Clk = <a class="code hl_function" href="../../d4/d07/group___n_a_n_o1_x2___t_i_m_e_r___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga56facc5683886f3ff3b273a3b5e47fcd">TIMER_GetModuleClock</a>(timer);</div>
<div class="line"><a id="l00091" name="l00091"></a><span class="lineno">   91</span>    uint32_t u32Prescale = 0, delay = <a class="code hl_variable" href="../../d9/dd8/system___nano1_x2_series_8h.html#aa3cd3e43291e81e795d642b79b6088e6">SystemCoreClock</a> / u32Clk;</div>
<div class="line"><a id="l00092" name="l00092"></a><span class="lineno">   92</span>    <span class="keywordtype">long</span> <span class="keywordtype">long</span> u64Cmpr;</div>
<div class="line"><a id="l00093" name="l00093"></a><span class="lineno">   93</span> </div>
<div class="line"><a id="l00094" name="l00094"></a><span class="lineno">   94</span>    <span class="comment">// Clear current timer configuration</span></div>
<div class="line"><a id="l00095" name="l00095"></a><span class="lineno">   95</span>    timer-&gt;<a class="code hl_variable" href="../../d4/d75/group___n_a_n_o1_x2__legacy___constants.html#gabb8d9df4695b742a04b52a7a64594322">CTL</a> = 0;</div>
<div class="line"><a id="l00096" name="l00096"></a><span class="lineno">   96</span> </div>
<div class="line"><a id="l00097" name="l00097"></a><span class="lineno">   97</span>    <span class="keywordflow">if</span>(u32Clk == 10000)           <span class="comment">// min delay is 100us if timer clock source is LIRC 10k</span></div>
<div class="line"><a id="l00098" name="l00098"></a><span class="lineno">   98</span>    {</div>
<div class="line"><a id="l00099" name="l00099"></a><span class="lineno">   99</span>        u32Usec = ((u32Usec + 99) / 100) * 100;</div>
<div class="line"><a id="l00100" name="l00100"></a><span class="lineno">  100</span>    }</div>
<div class="line"><a id="l00101" name="l00101"></a><span class="lineno">  101</span>    <span class="keywordflow">else</span>        <span class="comment">// 10 usec every step</span></div>
<div class="line"><a id="l00102" name="l00102"></a><span class="lineno">  102</span>    {</div>
<div class="line"><a id="l00103" name="l00103"></a><span class="lineno">  103</span>        u32Usec = ((u32Usec + 9) / 10) * 10;</div>
<div class="line"><a id="l00104" name="l00104"></a><span class="lineno">  104</span>    }</div>
<div class="line"><a id="l00105" name="l00105"></a><span class="lineno">  105</span> </div>
<div class="line"><a id="l00106" name="l00106"></a><span class="lineno">  106</span>    <span class="keywordflow">if</span>(u32Clk &gt; 0xFFFFFF)   <span class="comment">// For Nano1x2, only needs to consider 32MHz at most</span></div>
<div class="line"><a id="l00107" name="l00107"></a><span class="lineno">  107</span>    {</div>
<div class="line"><a id="l00108" name="l00108"></a><span class="lineno">  108</span>        u32Prescale = 1;</div>
<div class="line"><a id="l00109" name="l00109"></a><span class="lineno">  109</span>        u32Clk &gt;&gt;= 1;</div>
<div class="line"><a id="l00110" name="l00110"></a><span class="lineno">  110</span>    }</div>
<div class="line"><a id="l00111" name="l00111"></a><span class="lineno">  111</span> </div>
<div class="line"><a id="l00112" name="l00112"></a><span class="lineno">  112</span>    <span class="comment">// u32Usec * u32Clk might overflow if using uint32_t</span></div>
<div class="line"><a id="l00113" name="l00113"></a><span class="lineno">  113</span>    u64Cmpr = (<span class="keywordtype">long</span> long)u32Usec * (<span class="keywordtype">long</span> <span class="keywordtype">long</span>)u32Clk / (<span class="keywordtype">long</span> long)1000000;</div>
<div class="line"><a id="l00114" name="l00114"></a><span class="lineno">  114</span> </div>
<div class="line"><a id="l00115" name="l00115"></a><span class="lineno">  115</span>    timer-&gt;<a class="code hl_variable" href="../../d4/d75/group___n_a_n_o1_x2__legacy___constants.html#ga91eb63011da0934d7d8edcfb58566417">CMPR</a> = (uint32_t)u64Cmpr;</div>
<div class="line"><a id="l00116" name="l00116"></a><span class="lineno">  116</span>    timer-&gt;<a class="code hl_variable" href="../../d4/d75/group___n_a_n_o1_x2__legacy___constants.html#ga6a66d55fb7d20c3e12402aa320661d8f">PRECNT</a> = u32Prescale;</div>
<div class="line"><a id="l00117" name="l00117"></a><span class="lineno">  117</span>    timer-&gt;<a class="code hl_variable" href="../../d4/d75/group___n_a_n_o1_x2__legacy___constants.html#gabb8d9df4695b742a04b52a7a64594322">CTL</a> = <a class="code hl_define" href="../../da/d91/_nano1_x2_series_8h.html#a0a4046a38359302182a2a00a88a48754">TIMER_CTL_TMR_EN_Msk</a>; <span class="comment">// one shot mode</span></div>
<div class="line"><a id="l00118" name="l00118"></a><span class="lineno">  118</span> </div>
<div class="line"><a id="l00119" name="l00119"></a><span class="lineno">  119</span>    <span class="comment">// When system clock is faster than timer clock, it is possible timer active bit cannot set in time while we check it.</span></div>
<div class="line"><a id="l00120" name="l00120"></a><span class="lineno">  120</span>    <span class="comment">// And the while loop below return immediately, so put a tiny delay here allowing timer start counting and raise active flag.</span></div>
<div class="line"><a id="l00121" name="l00121"></a><span class="lineno">  121</span>    <span class="keywordflow">for</span>(; delay &gt; 0; delay--)</div>
<div class="line"><a id="l00122" name="l00122"></a><span class="lineno">  122</span>    {</div>
<div class="line"><a id="l00123" name="l00123"></a><span class="lineno">  123</span>        __NOP();</div>
<div class="line"><a id="l00124" name="l00124"></a><span class="lineno">  124</span>    }</div>
<div class="line"><a id="l00125" name="l00125"></a><span class="lineno">  125</span> </div>
<div class="line"><a id="l00126" name="l00126"></a><span class="lineno">  126</span>    delay = (<a class="code hl_variable" href="../../d9/dd8/system___nano1_x2_series_8h.html#aa3cd3e43291e81e795d642b79b6088e6">SystemCoreClock</a> / 1000000) * u32Usec * 10;</div>
<div class="line"><a id="l00127" name="l00127"></a><span class="lineno">  127</span>    </div>
<div class="line"><a id="l00128" name="l00128"></a><span class="lineno">  128</span>    <span class="keywordflow">while</span> ((timer-&gt;<a class="code hl_variable" href="../../d4/d75/group___n_a_n_o1_x2__legacy___constants.html#gabb8d9df4695b742a04b52a7a64594322">CTL</a> &amp; <a class="code hl_define" href="../../da/d91/_nano1_x2_series_8h.html#a7b6c38ccb02bcce02757c21efe40c555">TIMER_CTL_TMR_ACT_Msk</a>) &amp;&amp; (delay-- &gt; 0));</div>
<div class="line"><a id="l00129" name="l00129"></a><span class="lineno">  129</span>}</div>
<div class="line"><a id="l00130" name="l00130"></a><span class="lineno">  130</span> </div>
<div class="line"><a id="l00146" name="l00146"></a><span class="lineno"><a class="line" href="../../d4/d07/group___n_a_n_o1_x2___t_i_m_e_r___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga80ba64bdc40d36cb4a2139f4651b1c42">  146</a></span><span class="keywordtype">void</span> <a class="code hl_function" href="../../d4/d07/group___n_a_n_o1_x2___t_i_m_e_r___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga80ba64bdc40d36cb4a2139f4651b1c42">TIMER_EnableCapture</a>(<a class="code hl_struct" href="../../d9/d66/struct_t_i_m_e_r___t.html">TIMER_T</a> *timer, uint32_t u32CapMode, uint32_t u32Edge)</div>
<div class="line"><a id="l00147" name="l00147"></a><span class="lineno">  147</span>{</div>
<div class="line"><a id="l00148" name="l00148"></a><span class="lineno">  148</span> </div>
<div class="line"><a id="l00149" name="l00149"></a><span class="lineno">  149</span>    timer-&gt;<a class="code hl_variable" href="../../d4/d75/group___n_a_n_o1_x2__legacy___constants.html#gabb8d9df4695b742a04b52a7a64594322">CTL</a> = (timer-&gt;<a class="code hl_variable" href="../../d4/d75/group___n_a_n_o1_x2__legacy___constants.html#gabb8d9df4695b742a04b52a7a64594322">CTL</a> &amp; ~(<a class="code hl_define" href="../../da/d91/_nano1_x2_series_8h.html#a00db75e748324bce2b21b469de4f16df">TIMER_CTL_TCAP_MODE_Msk</a> |</div>
<div class="line"><a id="l00150" name="l00150"></a><span class="lineno">  150</span>                                 <a class="code hl_define" href="../../da/d91/_nano1_x2_series_8h.html#a075e98200974966cee8dc79d177ba0c9">TIMER_CTL_TCAP_CNT_MODE_Msk</a> |</div>
<div class="line"><a id="l00151" name="l00151"></a><span class="lineno">  151</span>                                 <a class="code hl_define" href="../../da/d91/_nano1_x2_series_8h.html#afc2f0f6c221fe6c3fb4f6dd7666284d8">TIMER_CTL_TCAP_EDGE_Msk</a>)) |</div>
<div class="line"><a id="l00152" name="l00152"></a><span class="lineno">  152</span>                 u32CapMode | u32Edge | <a class="code hl_define" href="../../da/d91/_nano1_x2_series_8h.html#ad17fb8844dcc08991b4dbc648f1ac49b">TIMER_CTL_TCAP_EN_Msk</a>;</div>
<div class="line"><a id="l00153" name="l00153"></a><span class="lineno">  153</span>}</div>
<div class="line"><a id="l00154" name="l00154"></a><span class="lineno">  154</span> </div>
<div class="line"><a id="l00160" name="l00160"></a><span class="lineno"><a class="line" href="../../d4/d07/group___n_a_n_o1_x2___t_i_m_e_r___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga1de0e4c2c84476d6c39d40a3bcaac18a">  160</a></span><span class="keywordtype">void</span> <a class="code hl_function" href="../../d4/d07/group___n_a_n_o1_x2___t_i_m_e_r___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga1de0e4c2c84476d6c39d40a3bcaac18a">TIMER_DisableCapture</a>(<a class="code hl_struct" href="../../d9/d66/struct_t_i_m_e_r___t.html">TIMER_T</a> *timer)</div>
<div class="line"><a id="l00161" name="l00161"></a><span class="lineno">  161</span>{</div>
<div class="line"><a id="l00162" name="l00162"></a><span class="lineno">  162</span>    timer-&gt;<a class="code hl_variable" href="../../d4/d75/group___n_a_n_o1_x2__legacy___constants.html#gabb8d9df4695b742a04b52a7a64594322">CTL</a> &amp;= ~TIMER_CTL_TCAP_EN_Msk;</div>
<div class="line"><a id="l00163" name="l00163"></a><span class="lineno">  163</span> </div>
<div class="line"><a id="l00164" name="l00164"></a><span class="lineno">  164</span>}</div>
<div class="line"><a id="l00165" name="l00165"></a><span class="lineno">  165</span> </div>
<div class="line"><a id="l00175" name="l00175"></a><span class="lineno"><a class="line" href="../../d4/d07/group___n_a_n_o1_x2___t_i_m_e_r___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga72fc8741562dbff619aa7dfe8b73c0a7">  175</a></span><span class="keywordtype">void</span> <a class="code hl_function" href="../../d4/d07/group___n_a_n_o1_x2___t_i_m_e_r___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga72fc8741562dbff619aa7dfe8b73c0a7">TIMER_EnableEventCounter</a>(<a class="code hl_struct" href="../../d9/d66/struct_t_i_m_e_r___t.html">TIMER_T</a> *timer, uint32_t u32Edge)</div>
<div class="line"><a id="l00176" name="l00176"></a><span class="lineno">  176</span>{</div>
<div class="line"><a id="l00177" name="l00177"></a><span class="lineno">  177</span>    timer-&gt;<a class="code hl_variable" href="../../d4/d75/group___n_a_n_o1_x2__legacy___constants.html#gabb8d9df4695b742a04b52a7a64594322">CTL</a> = (timer-&gt;<a class="code hl_variable" href="../../d4/d75/group___n_a_n_o1_x2__legacy___constants.html#gabb8d9df4695b742a04b52a7a64594322">CTL</a> &amp; ~TIMER_CTL_EVENT_EDGE_Msk) | u32Edge;</div>
<div class="line"><a id="l00178" name="l00178"></a><span class="lineno">  178</span>    timer-&gt;<a class="code hl_variable" href="../../d4/d75/group___n_a_n_o1_x2__legacy___constants.html#gabb8d9df4695b742a04b52a7a64594322">CTL</a> |= <a class="code hl_define" href="../../da/d91/_nano1_x2_series_8h.html#a09cf9a488f27614a75e7fbd5e66b91a8">TIMER_CTL_EVENT_EN_Msk</a>;</div>
<div class="line"><a id="l00179" name="l00179"></a><span class="lineno">  179</span>}</div>
<div class="line"><a id="l00180" name="l00180"></a><span class="lineno">  180</span> </div>
<div class="line"><a id="l00186" name="l00186"></a><span class="lineno"><a class="line" href="../../d4/d07/group___n_a_n_o1_x2___t_i_m_e_r___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga4460ba2e5f3bdddafab005e1e1fda0da">  186</a></span><span class="keywordtype">void</span> <a class="code hl_function" href="../../d4/d07/group___n_a_n_o1_x2___t_i_m_e_r___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga4460ba2e5f3bdddafab005e1e1fda0da">TIMER_DisableEventCounter</a>(<a class="code hl_struct" href="../../d9/d66/struct_t_i_m_e_r___t.html">TIMER_T</a> *timer)</div>
<div class="line"><a id="l00187" name="l00187"></a><span class="lineno">  187</span>{</div>
<div class="line"><a id="l00188" name="l00188"></a><span class="lineno">  188</span>    timer-&gt;<a class="code hl_variable" href="../../d4/d75/group___n_a_n_o1_x2__legacy___constants.html#gabb8d9df4695b742a04b52a7a64594322">CTL</a> &amp;= ~TIMER_CTL_EVENT_EN_Msk;</div>
<div class="line"><a id="l00189" name="l00189"></a><span class="lineno">  189</span>}</div>
<div class="line"><a id="l00190" name="l00190"></a><span class="lineno">  190</span> </div>
<div class="line"><a id="l00197" name="l00197"></a><span class="lineno"><a class="line" href="../../d4/d07/group___n_a_n_o1_x2___t_i_m_e_r___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga56facc5683886f3ff3b273a3b5e47fcd">  197</a></span>uint32_t <a class="code hl_function" href="../../d4/d07/group___n_a_n_o1_x2___t_i_m_e_r___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga56facc5683886f3ff3b273a3b5e47fcd">TIMER_GetModuleClock</a>(<a class="code hl_struct" href="../../d9/d66/struct_t_i_m_e_r___t.html">TIMER_T</a> *timer)</div>
<div class="line"><a id="l00198" name="l00198"></a><span class="lineno">  198</span>{</div>
<div class="line"><a id="l00199" name="l00199"></a><span class="lineno">  199</span>    uint32_t u32Src, u32Div;</div>
<div class="line"><a id="l00200" name="l00200"></a><span class="lineno">  200</span>    <span class="keyword">const</span> uint32_t au32Clk[] = {<a class="code hl_define" href="../../d9/dd8/system___nano1_x2_series_8h.html#a37c1644396b5996e92902bbf2dfc3ec5">__HXT</a>, <a class="code hl_define" href="../../d9/dd8/system___nano1_x2_series_8h.html#ab781074cbf310ee17748083dbe36ae98">__LXT</a>, <a class="code hl_define" href="../../d9/dd8/system___nano1_x2_series_8h.html#a6f446dd2f087f409b4fc986c0c25c2a9">__LIRC</a>, 0};   <span class="comment">// we don&#39;t know actual clock if external pin is clock source, set to 0 here</span></div>
<div class="line"><a id="l00201" name="l00201"></a><span class="lineno">  201</span> </div>
<div class="line"><a id="l00202" name="l00202"></a><span class="lineno">  202</span>    <span class="keywordflow">if</span>(timer == <a class="code hl_define" href="../../da/d2d/group___n_a_n_o1_x2___p_e_r_i_p_h_e_r_a_l___d_e_c_l_a_r_a_t_i_o_n.html#gaf1b746ba5ab7d0ab657156ebda0f290c">TIMER0</a>)</div>
<div class="line"><a id="l00203" name="l00203"></a><span class="lineno">  203</span>    {</div>
<div class="line"><a id="l00204" name="l00204"></a><span class="lineno">  204</span>        u32Src = (<a class="code hl_define" href="../../da/d2d/group___n_a_n_o1_x2___p_e_r_i_p_h_e_r_a_l___d_e_c_l_a_r_a_t_i_o_n.html#ga4b355291fe6b8ba8e167ab0faa862e45">CLK</a>-&gt;CLKSEL1 &amp; <a class="code hl_define" href="../../da/d80/group___n_a_n_o1_x2___definitions.html#gadf08d4f34c90e9b1ed984a2d0594f42c">CLK_CLKSEL1_TMR0_S_Msk</a>) &gt;&gt; <a class="code hl_define" href="../../da/d80/group___n_a_n_o1_x2___definitions.html#ga985995bc1ab0123a1aaa060fff194535">CLK_CLKSEL1_TMR0_S_Pos</a>;</div>
<div class="line"><a id="l00205" name="l00205"></a><span class="lineno">  205</span>        u32Div = (<a class="code hl_define" href="../../da/d2d/group___n_a_n_o1_x2___p_e_r_i_p_h_e_r_a_l___d_e_c_l_a_r_a_t_i_o_n.html#ga4b355291fe6b8ba8e167ab0faa862e45">CLK</a>-&gt;CLKDIV1 &amp; <a class="code hl_define" href="../../da/d80/group___n_a_n_o1_x2___definitions.html#gab296fd2db2b5a9528b9b758038243a73">CLK_CLKDIV1_TMR0_N_Msk</a>) &gt;&gt; <a class="code hl_define" href="../../da/d80/group___n_a_n_o1_x2___definitions.html#ga22fd63fe42d1d27a98e3c243df693b4a">CLK_CLKDIV1_TMR0_N_Pos</a>;</div>
<div class="line"><a id="l00206" name="l00206"></a><span class="lineno">  206</span>    }</div>
<div class="line"><a id="l00207" name="l00207"></a><span class="lineno">  207</span>    <span class="keywordflow">else</span> <span class="keywordflow">if</span>(timer == <a class="code hl_define" href="../../da/d2d/group___n_a_n_o1_x2___p_e_r_i_p_h_e_r_a_l___d_e_c_l_a_r_a_t_i_o_n.html#ga63bf4f24c85f26e838f55701a5e69831">TIMER1</a>)</div>
<div class="line"><a id="l00208" name="l00208"></a><span class="lineno">  208</span>    {</div>
<div class="line"><a id="l00209" name="l00209"></a><span class="lineno">  209</span>        u32Src = (<a class="code hl_define" href="../../da/d2d/group___n_a_n_o1_x2___p_e_r_i_p_h_e_r_a_l___d_e_c_l_a_r_a_t_i_o_n.html#ga4b355291fe6b8ba8e167ab0faa862e45">CLK</a>-&gt;CLKSEL1 &amp; <a class="code hl_define" href="../../da/d80/group___n_a_n_o1_x2___definitions.html#ga7baf8ad71c54b495a2d7c1c0e6788bc6">CLK_CLKSEL1_TMR1_S_Msk</a>) &gt;&gt; <a class="code hl_define" href="../../da/d80/group___n_a_n_o1_x2___definitions.html#gafcc261b9c98e0da4930bca8f7c20c88f">CLK_CLKSEL1_TMR1_S_Pos</a>;</div>
<div class="line"><a id="l00210" name="l00210"></a><span class="lineno">  210</span>        u32Div = (<a class="code hl_define" href="../../da/d2d/group___n_a_n_o1_x2___p_e_r_i_p_h_e_r_a_l___d_e_c_l_a_r_a_t_i_o_n.html#ga4b355291fe6b8ba8e167ab0faa862e45">CLK</a>-&gt;CLKDIV1 &amp; <a class="code hl_define" href="../../da/d80/group___n_a_n_o1_x2___definitions.html#ga056707f5bb6e089f03c8ec52baf20529">CLK_CLKDIV1_TMR1_N_Msk</a>) &gt;&gt; <a class="code hl_define" href="../../da/d80/group___n_a_n_o1_x2___definitions.html#ga923ba443c32e7c1d38d3de4e4b1743aa">CLK_CLKDIV1_TMR1_N_Pos</a>;</div>
<div class="line"><a id="l00211" name="l00211"></a><span class="lineno">  211</span>    }</div>
<div class="line"><a id="l00212" name="l00212"></a><span class="lineno">  212</span>    <span class="keywordflow">else</span> <span class="keywordflow">if</span>(timer == <a class="code hl_define" href="../../da/d2d/group___n_a_n_o1_x2___p_e_r_i_p_h_e_r_a_l___d_e_c_l_a_r_a_t_i_o_n.html#gaca904d0e4ebb6d643c349f7f05613995">TIMER2</a>)</div>
<div class="line"><a id="l00213" name="l00213"></a><span class="lineno">  213</span>    {</div>
<div class="line"><a id="l00214" name="l00214"></a><span class="lineno">  214</span>        u32Src = (<a class="code hl_define" href="../../da/d2d/group___n_a_n_o1_x2___p_e_r_i_p_h_e_r_a_l___d_e_c_l_a_r_a_t_i_o_n.html#ga4b355291fe6b8ba8e167ab0faa862e45">CLK</a>-&gt;CLKSEL2 &amp; <a class="code hl_define" href="../../da/d80/group___n_a_n_o1_x2___definitions.html#ga55afd11f83a44eb3bc69d1366981782f">CLK_CLKSEL2_TMR2_S_Msk</a>) &gt;&gt; <a class="code hl_define" href="../../da/d80/group___n_a_n_o1_x2___definitions.html#ga4b0df8cd455db2f1e22676bcaa48295b">CLK_CLKSEL2_TMR2_S_Pos</a>;</div>
<div class="line"><a id="l00215" name="l00215"></a><span class="lineno">  215</span>        u32Div = (<a class="code hl_define" href="../../da/d2d/group___n_a_n_o1_x2___p_e_r_i_p_h_e_r_a_l___d_e_c_l_a_r_a_t_i_o_n.html#ga4b355291fe6b8ba8e167ab0faa862e45">CLK</a>-&gt;CLKDIV1 &amp; <a class="code hl_define" href="../../da/d80/group___n_a_n_o1_x2___definitions.html#ga95259ed050f03ba2789cba990c3f447b">CLK_CLKDIV1_TMR2_N_Msk</a>) &gt;&gt; <a class="code hl_define" href="../../da/d80/group___n_a_n_o1_x2___definitions.html#ga7744354d75109a3b0c3cdeed8cd61638">CLK_CLKDIV1_TMR2_N_Pos</a>;</div>
<div class="line"><a id="l00216" name="l00216"></a><span class="lineno">  216</span>    }</div>
<div class="line"><a id="l00217" name="l00217"></a><span class="lineno">  217</span>    <span class="keywordflow">else</span>    <span class="comment">// Timer 3</span></div>
<div class="line"><a id="l00218" name="l00218"></a><span class="lineno">  218</span>    {</div>
<div class="line"><a id="l00219" name="l00219"></a><span class="lineno">  219</span>        u32Src = (<a class="code hl_define" href="../../da/d2d/group___n_a_n_o1_x2___p_e_r_i_p_h_e_r_a_l___d_e_c_l_a_r_a_t_i_o_n.html#ga4b355291fe6b8ba8e167ab0faa862e45">CLK</a>-&gt;CLKSEL2 &amp; <a class="code hl_define" href="../../da/d80/group___n_a_n_o1_x2___definitions.html#ga75dd6dd3907ef9cd4f4a88463a40945b">CLK_CLKSEL2_TMR3_S_Msk</a>) &gt;&gt; <a class="code hl_define" href="../../da/d80/group___n_a_n_o1_x2___definitions.html#ga4b839880d8afb519ca20312af7df55fd">CLK_CLKSEL2_TMR3_S_Pos</a>;</div>
<div class="line"><a id="l00220" name="l00220"></a><span class="lineno">  220</span>        u32Div = (<a class="code hl_define" href="../../da/d2d/group___n_a_n_o1_x2___p_e_r_i_p_h_e_r_a_l___d_e_c_l_a_r_a_t_i_o_n.html#ga4b355291fe6b8ba8e167ab0faa862e45">CLK</a>-&gt;CLKDIV1 &amp; <a class="code hl_define" href="../../da/d80/group___n_a_n_o1_x2___definitions.html#gaf7e17748e92034d8547e952c3ccc063a">CLK_CLKDIV1_TMR3_N_Msk</a>) &gt;&gt; <a class="code hl_define" href="../../da/d80/group___n_a_n_o1_x2___definitions.html#ga660d4e334ce55937d578dd00e6710ca4">CLK_CLKDIV1_TMR3_N_Pos</a>;</div>
<div class="line"><a id="l00221" name="l00221"></a><span class="lineno">  221</span>    }</div>
<div class="line"><a id="l00222" name="l00222"></a><span class="lineno">  222</span>    u32Div++;</div>
<div class="line"><a id="l00223" name="l00223"></a><span class="lineno">  223</span>    <span class="keywordflow">if</span>(u32Src &lt; 4)</div>
<div class="line"><a id="l00224" name="l00224"></a><span class="lineno">  224</span>        <span class="keywordflow">return</span> au32Clk[u32Src] / u32Div;</div>
<div class="line"><a id="l00225" name="l00225"></a><span class="lineno">  225</span>    <span class="keywordflow">else</span> <span class="keywordflow">if</span>(u32Src == 4)</div>
<div class="line"><a id="l00226" name="l00226"></a><span class="lineno">  226</span>    {</div>
<div class="line"><a id="l00227" name="l00227"></a><span class="lineno">  227</span>        <span class="keywordflow">if</span>((<a class="code hl_define" href="../../da/d2d/group___n_a_n_o1_x2___p_e_r_i_p_h_e_r_a_l___d_e_c_l_a_r_a_t_i_o_n.html#ga4b355291fe6b8ba8e167ab0faa862e45">CLK</a>-&gt;PWRCTL &amp; <a class="code hl_define" href="../../da/d80/group___n_a_n_o1_x2___definitions.html#gac3544758fe7062fa3b3246b1ae15f60b">CLK_PWRCTL_HIRC_FSEL_Msk</a>) == <a class="code hl_define" href="../../da/d80/group___n_a_n_o1_x2___definitions.html#gac3544758fe7062fa3b3246b1ae15f60b">CLK_PWRCTL_HIRC_FSEL_Msk</a>)</div>
<div class="line"><a id="l00228" name="l00228"></a><span class="lineno">  228</span>            <span class="keywordflow">return</span> <a class="code hl_define" href="../../d9/dd8/system___nano1_x2_series_8h.html#aae5c5ec4722a291e1271743d45414223">__HIRC16M</a> / u32Div;</div>
<div class="line"><a id="l00229" name="l00229"></a><span class="lineno">  229</span>        <span class="keywordflow">else</span></div>
<div class="line"><a id="l00230" name="l00230"></a><span class="lineno">  230</span>            <span class="keywordflow">return</span> <a class="code hl_define" href="../../d9/dd8/system___nano1_x2_series_8h.html#ad145c32431f633b887d84ef0c78f42f3">__HIRC12M</a> / u32Div;</div>
<div class="line"><a id="l00231" name="l00231"></a><span class="lineno">  231</span>    }</div>
<div class="line"><a id="l00232" name="l00232"></a><span class="lineno">  232</span>    <span class="keywordflow">else</span></div>
<div class="line"><a id="l00233" name="l00233"></a><span class="lineno">  233</span>        <span class="keywordflow">return</span> <a class="code hl_function" href="../../d5/d72/group___n_a_n_o1_x2___c_l_k___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga27ded0f4435751be979927718884488f">CLK_GetHCLKFreq</a>() / u32Div;</div>
<div class="line"><a id="l00234" name="l00234"></a><span class="lineno">  234</span>}</div>
<div class="line"><a id="l00235" name="l00235"></a><span class="lineno">  235</span> </div>
<div class="line"><a id="l00241" name="l00241"></a><span class="lineno"><a class="line" href="../../d4/d07/group___n_a_n_o1_x2___t_i_m_e_r___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga452e6b15e2da57f1bb4432e01831c818">  241</a></span><span class="keywordtype">void</span> <a class="code hl_function" href="../../d4/d07/group___n_a_n_o1_x2___t_i_m_e_r___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga452e6b15e2da57f1bb4432e01831c818">TIMER_ResetCounter</a>(<a class="code hl_struct" href="../../d9/d66/struct_t_i_m_e_r___t.html">TIMER_T</a> *timer)</div>
<div class="line"><a id="l00242" name="l00242"></a><span class="lineno">  242</span>{</div>
<div class="line"><a id="l00243" name="l00243"></a><span class="lineno">  243</span>    <span class="comment">// A write with any value to TIMER DR register will trigger timer counter reset</span></div>
<div class="line"><a id="l00244" name="l00244"></a><span class="lineno">  244</span>    timer-&gt;<a class="code hl_variable" href="../../d4/d75/group___n_a_n_o1_x2__legacy___constants.html#ga7f5ea6a1af3b26e732ffec08d4d519f5">DR</a> = 0;</div>
<div class="line"><a id="l00245" name="l00245"></a><span class="lineno">  245</span>}</div>
<div class="line"><a id="l00246" name="l00246"></a><span class="lineno">  246</span> </div>
<div class="line"><a id="l00264" name="l00264"></a><span class="lineno"><a class="line" href="../../d4/d07/group___n_a_n_o1_x2___t_i_m_e_r___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#gaaf424bb31a227f8d672f337e5c6a6059">  264</a></span><span class="keywordtype">void</span> <a class="code hl_function" href="../../d4/d07/group___n_a_n_o1_x2___t_i_m_e_r___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#gaaf424bb31a227f8d672f337e5c6a6059">TIMER_EnableFreqCounter</a>(<a class="code hl_struct" href="../../d9/d66/struct_t_i_m_e_r___t.html">TIMER_T</a> *timer,</div>
<div class="line"><a id="l00265" name="l00265"></a><span class="lineno">  265</span>                             uint32_t u32DropCount,</div>
<div class="line"><a id="l00266" name="l00266"></a><span class="lineno">  266</span>                             uint32_t u32Timeout,</div>
<div class="line"><a id="l00267" name="l00267"></a><span class="lineno">  267</span>                             uint32_t u32EnableInt)</div>
<div class="line"><a id="l00268" name="l00268"></a><span class="lineno">  268</span>{</div>
<div class="line"><a id="l00269" name="l00269"></a><span class="lineno">  269</span>    uint32_t mode = <a class="code hl_define" href="../../da/d91/_nano1_x2_series_8h.html#a08082e24e7711202f5a30aaf07bb074f">TIMER_CTL_INTR_TRG_EN_Msk</a>;</div>
<div class="line"><a id="l00270" name="l00270"></a><span class="lineno">  270</span>    <a class="code hl_struct" href="../../d9/d66/struct_t_i_m_e_r___t.html">TIMER_T</a> *t;    <span class="comment">// store the timer base to configure compare value</span></div>
<div class="line"><a id="l00271" name="l00271"></a><span class="lineno">  271</span> </div>
<div class="line"><a id="l00272" name="l00272"></a><span class="lineno">  272</span>    <span class="keywordflow">if</span>(u32DropCount != 0 || u32Timeout &gt;= 2)</div>
<div class="line"><a id="l00273" name="l00273"></a><span class="lineno">  273</span>        mode |= <a class="code hl_define" href="../../da/d91/_nano1_x2_series_8h.html#a6fe9f13b4b001247ba00554007cbc769">TIMER_CTL_INTR_TRG_MODE_Msk</a>;</div>
<div class="line"><a id="l00274" name="l00274"></a><span class="lineno">  274</span>    <span class="keywordflow">if</span>(u32Timeout &lt; 2)</div>
<div class="line"><a id="l00275" name="l00275"></a><span class="lineno">  275</span>        u32Timeout = 0xFFFFFF;</div>
<div class="line"><a id="l00276" name="l00276"></a><span class="lineno">  276</span> </div>
<div class="line"><a id="l00277" name="l00277"></a><span class="lineno">  277</span>    timer-&gt;<a class="code hl_variable" href="../../d4/d75/group___n_a_n_o1_x2__legacy___constants.html#gaf6e91877db4ad3b35116bbd1c281bda6">ECTL</a> = u32DropCount &lt;&lt; <a class="code hl_define" href="../../da/d91/_nano1_x2_series_8h.html#a156ef1b4a2df44c329d5e8963aade483">TIMER_ECTL_EVNT_DROP_CNT_Pos</a>;</div>
<div class="line"><a id="l00278" name="l00278"></a><span class="lineno">  278</span>    t = (timer == <a class="code hl_define" href="../../da/d2d/group___n_a_n_o1_x2___p_e_r_i_p_h_e_r_a_l___d_e_c_l_a_r_a_t_i_o_n.html#gaf1b746ba5ab7d0ab657156ebda0f290c">TIMER0</a>) ? <a class="code hl_define" href="../../da/d2d/group___n_a_n_o1_x2___p_e_r_i_p_h_e_r_a_l___d_e_c_l_a_r_a_t_i_o_n.html#ga63bf4f24c85f26e838f55701a5e69831">TIMER1</a> : <a class="code hl_define" href="../../da/d2d/group___n_a_n_o1_x2___p_e_r_i_p_h_e_r_a_l___d_e_c_l_a_r_a_t_i_o_n.html#ga6d4063b72c434f0e7afa8eb2a0e7ee00">TIMER3</a>;</div>
<div class="line"><a id="l00279" name="l00279"></a><span class="lineno">  279</span> </div>
<div class="line"><a id="l00280" name="l00280"></a><span class="lineno">  280</span>    t-&gt;<a class="code hl_variable" href="../../d4/d75/group___n_a_n_o1_x2__legacy___constants.html#ga91eb63011da0934d7d8edcfb58566417">CMPR</a> = u32Timeout;</div>
<div class="line"><a id="l00281" name="l00281"></a><span class="lineno">  281</span>    t-&gt;<a class="code hl_variable" href="../../d4/d75/group___n_a_n_o1_x2__legacy___constants.html#ga1b93de0ad6cd08676926bcff6888c10d">IER</a> = u32EnableInt ? <a class="code hl_define" href="../../da/d91/_nano1_x2_series_8h.html#a2d892ba5d7d198be075c9844341e7357">TIMER_IER_TCAP_IE_Msk</a> : 0;</div>
<div class="line"><a id="l00282" name="l00282"></a><span class="lineno">  282</span>    timer-&gt;<a class="code hl_variable" href="../../d4/d75/group___n_a_n_o1_x2__legacy___constants.html#gabb8d9df4695b742a04b52a7a64594322">CTL</a> = mode | <a class="code hl_define" href="../../da/d91/_nano1_x2_series_8h.html#a0a4046a38359302182a2a00a88a48754">TIMER_CTL_TMR_EN_Msk</a>;</div>
<div class="line"><a id="l00283" name="l00283"></a><span class="lineno">  283</span> </div>
<div class="line"><a id="l00284" name="l00284"></a><span class="lineno">  284</span>    <span class="keywordflow">return</span>;</div>
<div class="line"><a id="l00285" name="l00285"></a><span class="lineno">  285</span>}</div>
<div class="line"><a id="l00291" name="l00291"></a><span class="lineno"><a class="line" href="../../d4/d07/group___n_a_n_o1_x2___t_i_m_e_r___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga709e58fa2804ed056f2e77f4b26cf686">  291</a></span><span class="keywordtype">void</span> <a class="code hl_function" href="../../d4/d07/group___n_a_n_o1_x2___t_i_m_e_r___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga709e58fa2804ed056f2e77f4b26cf686">TIMER_DisableFreqCounter</a>(<a class="code hl_struct" href="../../d9/d66/struct_t_i_m_e_r___t.html">TIMER_T</a> *timer)</div>
<div class="line"><a id="l00292" name="l00292"></a><span class="lineno">  292</span>{</div>
<div class="line"><a id="l00293" name="l00293"></a><span class="lineno">  293</span>    timer-&gt;<a class="code hl_variable" href="../../d4/d75/group___n_a_n_o1_x2__legacy___constants.html#gabb8d9df4695b742a04b52a7a64594322">CTL</a> &amp;= ~(<a class="code hl_define" href="../../da/d91/_nano1_x2_series_8h.html#a08082e24e7711202f5a30aaf07bb074f">TIMER_CTL_INTR_TRG_EN_Msk</a> | <a class="code hl_define" href="../../da/d91/_nano1_x2_series_8h.html#a6fe9f13b4b001247ba00554007cbc769">TIMER_CTL_INTR_TRG_MODE_Msk</a>);</div>
<div class="line"><a id="l00294" name="l00294"></a><span class="lineno">  294</span>}</div>
<div class="line"><a id="l00295" name="l00295"></a><span class="lineno">  295</span> </div>
<div class="line"><a id="l00304" name="l00304"></a><span class="lineno"><a class="line" href="../../d4/d07/group___n_a_n_o1_x2___t_i_m_e_r___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga0d86a240e96da7b8db2c11f4bbb46693">  304</a></span><span class="keywordtype">void</span> <a class="code hl_function" href="../../d4/d07/group___n_a_n_o1_x2___t_i_m_e_r___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga0d86a240e96da7b8db2c11f4bbb46693">TIMER_SetTriggerSource</a>(<a class="code hl_struct" href="../../d9/d66/struct_t_i_m_e_r___t.html">TIMER_T</a> *timer, uint32_t u32Src)</div>
<div class="line"><a id="l00305" name="l00305"></a><span class="lineno">  305</span>{</div>
<div class="line"><a id="l00306" name="l00306"></a><span class="lineno">  306</span>    timer-&gt;<a class="code hl_variable" href="../../d4/d75/group___n_a_n_o1_x2__legacy___constants.html#gabb8d9df4695b742a04b52a7a64594322">CTL</a> = (timer-&gt;<a class="code hl_variable" href="../../d4/d75/group___n_a_n_o1_x2__legacy___constants.html#gabb8d9df4695b742a04b52a7a64594322">CTL</a> &amp; ~TIMER_CTL_CAP_TRG_EN_Msk) | u32Src;</div>
<div class="line"><a id="l00307" name="l00307"></a><span class="lineno">  307</span>}</div>
<div class="line"><a id="l00308" name="l00308"></a><span class="lineno">  308</span> </div>
<div class="line"><a id="l00317" name="l00317"></a><span class="lineno"><a class="line" href="../../d4/d07/group___n_a_n_o1_x2___t_i_m_e_r___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#gaa01b131e6bd3d6c51662670377d32c97">  317</a></span><span class="keywordtype">void</span> <a class="code hl_function" href="../../d4/d07/group___n_a_n_o1_x2___t_i_m_e_r___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#gaa01b131e6bd3d6c51662670377d32c97">TIMER_SetTriggerTarget</a>(<a class="code hl_struct" href="../../d9/d66/struct_t_i_m_e_r___t.html">TIMER_T</a> *timer, uint32_t u32Mask)</div>
<div class="line"><a id="l00318" name="l00318"></a><span class="lineno">  318</span>{</div>
<div class="line"><a id="l00319" name="l00319"></a><span class="lineno">  319</span>    timer-&gt;<a class="code hl_variable" href="../../d4/d75/group___n_a_n_o1_x2__legacy___constants.html#gabb8d9df4695b742a04b52a7a64594322">CTL</a> = (timer-&gt;<a class="code hl_variable" href="../../d4/d75/group___n_a_n_o1_x2__legacy___constants.html#gabb8d9df4695b742a04b52a7a64594322">CTL</a> &amp; ~(<a class="code hl_define" href="../../da/d91/_nano1_x2_series_8h.html#a39f79f09f63b65656028595e780504f9">TIMER_CTL_PDMA_TEEN_Msk</a> | <a class="code hl_define" href="../../da/d91/_nano1_x2_series_8h.html#ab38ae46e13051b41cb4f26b707851f25">TIMER_CTL_ADC_TEEN_Msk</a>)) | u32Mask;</div>
<div class="line"><a id="l00320" name="l00320"></a><span class="lineno">  320</span>}</div>
<div class="line"><a id="l00321" name="l00321"></a><span class="lineno">  321</span> <span class="comment">/* end of group NANO1X2_TIMER_EXPORTED_FUNCTIONS */</span></div>
<div class="line"><a id="l00323" name="l00323"></a><span class="lineno">  323</span> <span class="comment">/* end of group NANO1X2_TIMER_Driver */</span></div>
<div class="line"><a id="l00325" name="l00325"></a><span class="lineno">  325</span> <span class="comment">/* end of group NANO1X2_Device_Driver */</span></div>
<div class="line"><a id="l00327" name="l00327"></a><span class="lineno">  327</span> </div>
<div class="line"><a id="l00328" name="l00328"></a><span class="lineno">  328</span><span class="comment">/*** (C) COPYRIGHT 2015 Nuvoton Technology Corp. ***/</span></div>
<div class="ttc" id="a_nano1_x2_series_8h_html"><div class="ttname"><a href="../../da/d91/_nano1_x2_series_8h.html">Nano1X2Series.h</a></div><div class="ttdoc">Nano102/112 peripheral access layer header file. This file contains all the peripheral register's def...</div></div>
<div class="ttc" id="a_nano1_x2_series_8h_html_a00db75e748324bce2b21b469de4f16df"><div class="ttname"><a href="../../da/d91/_nano1_x2_series_8h.html#a00db75e748324bce2b21b469de4f16df">TIMER_CTL_TCAP_MODE_Msk</a></div><div class="ttdeci">#define TIMER_CTL_TCAP_MODE_Msk</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d91/_nano1_x2_series_8h_source.html#l09398">Nano1X2Series.h:9398</a></div></div>
<div class="ttc" id="a_nano1_x2_series_8h_html_a075e98200974966cee8dc79d177ba0c9"><div class="ttname"><a href="../../da/d91/_nano1_x2_series_8h.html#a075e98200974966cee8dc79d177ba0c9">TIMER_CTL_TCAP_CNT_MODE_Msk</a></div><div class="ttdeci">#define TIMER_CTL_TCAP_CNT_MODE_Msk</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d91/_nano1_x2_series_8h_source.html#l09404">Nano1X2Series.h:9404</a></div></div>
<div class="ttc" id="a_nano1_x2_series_8h_html_a08082e24e7711202f5a30aaf07bb074f"><div class="ttname"><a href="../../da/d91/_nano1_x2_series_8h.html#a08082e24e7711202f5a30aaf07bb074f">TIMER_CTL_INTR_TRG_EN_Msk</a></div><div class="ttdeci">#define TIMER_CTL_INTR_TRG_EN_Msk</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d91/_nano1_x2_series_8h_source.html#l09410">Nano1X2Series.h:9410</a></div></div>
<div class="ttc" id="a_nano1_x2_series_8h_html_a09cf9a488f27614a75e7fbd5e66b91a8"><div class="ttname"><a href="../../da/d91/_nano1_x2_series_8h.html#a09cf9a488f27614a75e7fbd5e66b91a8">TIMER_CTL_EVENT_EN_Msk</a></div><div class="ttdeci">#define TIMER_CTL_EVENT_EN_Msk</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d91/_nano1_x2_series_8h_source.html#l09386">Nano1X2Series.h:9386</a></div></div>
<div class="ttc" id="a_nano1_x2_series_8h_html_a0a4046a38359302182a2a00a88a48754"><div class="ttname"><a href="../../da/d91/_nano1_x2_series_8h.html#a0a4046a38359302182a2a00a88a48754">TIMER_CTL_TMR_EN_Msk</a></div><div class="ttdeci">#define TIMER_CTL_TMR_EN_Msk</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d91/_nano1_x2_series_8h_source.html#l09353">Nano1X2Series.h:9353</a></div></div>
<div class="ttc" id="a_nano1_x2_series_8h_html_a156ef1b4a2df44c329d5e8963aade483"><div class="ttname"><a href="../../da/d91/_nano1_x2_series_8h.html#a156ef1b4a2df44c329d5e8963aade483">TIMER_ECTL_EVNT_DROP_CNT_Pos</a></div><div class="ttdeci">#define TIMER_ECTL_EVNT_DROP_CNT_Pos</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d91/_nano1_x2_series_8h_source.html#l09466">Nano1X2Series.h:9466</a></div></div>
<div class="ttc" id="a_nano1_x2_series_8h_html_a2d892ba5d7d198be075c9844341e7357"><div class="ttname"><a href="../../da/d91/_nano1_x2_series_8h.html#a2d892ba5d7d198be075c9844341e7357">TIMER_IER_TCAP_IE_Msk</a></div><div class="ttdeci">#define TIMER_IER_TCAP_IE_Msk</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d91/_nano1_x2_series_8h_source.html#l09425">Nano1X2Series.h:9425</a></div></div>
<div class="ttc" id="a_nano1_x2_series_8h_html_a39f79f09f63b65656028595e780504f9"><div class="ttname"><a href="../../da/d91/_nano1_x2_series_8h.html#a39f79f09f63b65656028595e780504f9">TIMER_CTL_PDMA_TEEN_Msk</a></div><div class="ttdeci">#define TIMER_CTL_PDMA_TEEN_Msk</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d91/_nano1_x2_series_8h_source.html#l09380">Nano1X2Series.h:9380</a></div></div>
<div class="ttc" id="a_nano1_x2_series_8h_html_a6fe9f13b4b001247ba00554007cbc769"><div class="ttname"><a href="../../da/d91/_nano1_x2_series_8h.html#a6fe9f13b4b001247ba00554007cbc769">TIMER_CTL_INTR_TRG_MODE_Msk</a></div><div class="ttdeci">#define TIMER_CTL_INTR_TRG_MODE_Msk</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d91/_nano1_x2_series_8h_source.html#l09413">Nano1X2Series.h:9413</a></div></div>
<div class="ttc" id="a_nano1_x2_series_8h_html_a7b6c38ccb02bcce02757c21efe40c555"><div class="ttname"><a href="../../da/d91/_nano1_x2_series_8h.html#a7b6c38ccb02bcce02757c21efe40c555">TIMER_CTL_TMR_ACT_Msk</a></div><div class="ttdeci">#define TIMER_CTL_TMR_ACT_Msk</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d91/_nano1_x2_series_8h_source.html#l09371">Nano1X2Series.h:9371</a></div></div>
<div class="ttc" id="a_nano1_x2_series_8h_html_ab38ae46e13051b41cb4f26b707851f25"><div class="ttname"><a href="../../da/d91/_nano1_x2_series_8h.html#ab38ae46e13051b41cb4f26b707851f25">TIMER_CTL_ADC_TEEN_Msk</a></div><div class="ttdeci">#define TIMER_CTL_ADC_TEEN_Msk</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d91/_nano1_x2_series_8h_source.html#l09374">Nano1X2Series.h:9374</a></div></div>
<div class="ttc" id="a_nano1_x2_series_8h_html_ad17fb8844dcc08991b4dbc648f1ac49b"><div class="ttname"><a href="../../da/d91/_nano1_x2_series_8h.html#ad17fb8844dcc08991b4dbc648f1ac49b">TIMER_CTL_TCAP_EN_Msk</a></div><div class="ttdeci">#define TIMER_CTL_TCAP_EN_Msk</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d91/_nano1_x2_series_8h_source.html#l09395">Nano1X2Series.h:9395</a></div></div>
<div class="ttc" id="a_nano1_x2_series_8h_html_afc2f0f6c221fe6c3fb4f6dd7666284d8"><div class="ttname"><a href="../../da/d91/_nano1_x2_series_8h.html#afc2f0f6c221fe6c3fb4f6dd7666284d8">TIMER_CTL_TCAP_EDGE_Msk</a></div><div class="ttdeci">#define TIMER_CTL_TCAP_EDGE_Msk</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d91/_nano1_x2_series_8h_source.html#l09401">Nano1X2Series.h:9401</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___c_l_k___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s_html_ga27ded0f4435751be979927718884488f"><div class="ttname"><a href="../../d5/d72/group___n_a_n_o1_x2___c_l_k___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga27ded0f4435751be979927718884488f">CLK_GetHCLKFreq</a></div><div class="ttdeci">uint32_t CLK_GetHCLKFreq(void)</div><div class="ttdoc">This function get HCLK frequency. The frequency unit is Hz.</div><div class="ttdef"><b>Definition:</b> <a href="../../de/da0/clk_8c_source.html#l00192">clk.c:192</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___definitions_html_ga056707f5bb6e089f03c8ec52baf20529"><div class="ttname"><a href="../../da/d80/group___n_a_n_o1_x2___definitions.html#ga056707f5bb6e089f03c8ec52baf20529">CLK_CLKDIV1_TMR1_N_Msk</a></div><div class="ttdeci">#define CLK_CLKDIV1_TMR1_N_Msk</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d91/_nano1_x2_series_8h_source.html#l01634">Nano1X2Series.h:1634</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___definitions_html_ga22fd63fe42d1d27a98e3c243df693b4a"><div class="ttname"><a href="../../da/d80/group___n_a_n_o1_x2___definitions.html#ga22fd63fe42d1d27a98e3c243df693b4a">CLK_CLKDIV1_TMR0_N_Pos</a></div><div class="ttdeci">#define CLK_CLKDIV1_TMR0_N_Pos</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d91/_nano1_x2_series_8h_source.html#l01630">Nano1X2Series.h:1630</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___definitions_html_ga4b0df8cd455db2f1e22676bcaa48295b"><div class="ttname"><a href="../../da/d80/group___n_a_n_o1_x2___definitions.html#ga4b0df8cd455db2f1e22676bcaa48295b">CLK_CLKSEL2_TMR2_S_Pos</a></div><div class="ttdeci">#define CLK_CLKSEL2_TMR2_S_Pos</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d91/_nano1_x2_series_8h_source.html#l01600">Nano1X2Series.h:1600</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___definitions_html_ga4b839880d8afb519ca20312af7df55fd"><div class="ttname"><a href="../../da/d80/group___n_a_n_o1_x2___definitions.html#ga4b839880d8afb519ca20312af7df55fd">CLK_CLKSEL2_TMR3_S_Pos</a></div><div class="ttdeci">#define CLK_CLKSEL2_TMR3_S_Pos</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d91/_nano1_x2_series_8h_source.html#l01603">Nano1X2Series.h:1603</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___definitions_html_ga55afd11f83a44eb3bc69d1366981782f"><div class="ttname"><a href="../../da/d80/group___n_a_n_o1_x2___definitions.html#ga55afd11f83a44eb3bc69d1366981782f">CLK_CLKSEL2_TMR2_S_Msk</a></div><div class="ttdeci">#define CLK_CLKSEL2_TMR2_S_Msk</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d91/_nano1_x2_series_8h_source.html#l01601">Nano1X2Series.h:1601</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___definitions_html_ga660d4e334ce55937d578dd00e6710ca4"><div class="ttname"><a href="../../da/d80/group___n_a_n_o1_x2___definitions.html#ga660d4e334ce55937d578dd00e6710ca4">CLK_CLKDIV1_TMR3_N_Pos</a></div><div class="ttdeci">#define CLK_CLKDIV1_TMR3_N_Pos</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d91/_nano1_x2_series_8h_source.html#l01639">Nano1X2Series.h:1639</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___definitions_html_ga75dd6dd3907ef9cd4f4a88463a40945b"><div class="ttname"><a href="../../da/d80/group___n_a_n_o1_x2___definitions.html#ga75dd6dd3907ef9cd4f4a88463a40945b">CLK_CLKSEL2_TMR3_S_Msk</a></div><div class="ttdeci">#define CLK_CLKSEL2_TMR3_S_Msk</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d91/_nano1_x2_series_8h_source.html#l01604">Nano1X2Series.h:1604</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___definitions_html_ga7744354d75109a3b0c3cdeed8cd61638"><div class="ttname"><a href="../../da/d80/group___n_a_n_o1_x2___definitions.html#ga7744354d75109a3b0c3cdeed8cd61638">CLK_CLKDIV1_TMR2_N_Pos</a></div><div class="ttdeci">#define CLK_CLKDIV1_TMR2_N_Pos</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d91/_nano1_x2_series_8h_source.html#l01636">Nano1X2Series.h:1636</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___definitions_html_ga7baf8ad71c54b495a2d7c1c0e6788bc6"><div class="ttname"><a href="../../da/d80/group___n_a_n_o1_x2___definitions.html#ga7baf8ad71c54b495a2d7c1c0e6788bc6">CLK_CLKSEL1_TMR1_S_Msk</a></div><div class="ttdeci">#define CLK_CLKSEL1_TMR1_S_Msk</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d91/_nano1_x2_series_8h_source.html#l01586">Nano1X2Series.h:1586</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___definitions_html_ga923ba443c32e7c1d38d3de4e4b1743aa"><div class="ttname"><a href="../../da/d80/group___n_a_n_o1_x2___definitions.html#ga923ba443c32e7c1d38d3de4e4b1743aa">CLK_CLKDIV1_TMR1_N_Pos</a></div><div class="ttdeci">#define CLK_CLKDIV1_TMR1_N_Pos</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d91/_nano1_x2_series_8h_source.html#l01633">Nano1X2Series.h:1633</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___definitions_html_ga95259ed050f03ba2789cba990c3f447b"><div class="ttname"><a href="../../da/d80/group___n_a_n_o1_x2___definitions.html#ga95259ed050f03ba2789cba990c3f447b">CLK_CLKDIV1_TMR2_N_Msk</a></div><div class="ttdeci">#define CLK_CLKDIV1_TMR2_N_Msk</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d91/_nano1_x2_series_8h_source.html#l01637">Nano1X2Series.h:1637</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___definitions_html_ga985995bc1ab0123a1aaa060fff194535"><div class="ttname"><a href="../../da/d80/group___n_a_n_o1_x2___definitions.html#ga985995bc1ab0123a1aaa060fff194535">CLK_CLKSEL1_TMR0_S_Pos</a></div><div class="ttdeci">#define CLK_CLKSEL1_TMR0_S_Pos</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d91/_nano1_x2_series_8h_source.html#l01582">Nano1X2Series.h:1582</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___definitions_html_gab296fd2db2b5a9528b9b758038243a73"><div class="ttname"><a href="../../da/d80/group___n_a_n_o1_x2___definitions.html#gab296fd2db2b5a9528b9b758038243a73">CLK_CLKDIV1_TMR0_N_Msk</a></div><div class="ttdeci">#define CLK_CLKDIV1_TMR0_N_Msk</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d91/_nano1_x2_series_8h_source.html#l01631">Nano1X2Series.h:1631</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___definitions_html_gac3544758fe7062fa3b3246b1ae15f60b"><div class="ttname"><a href="../../da/d80/group___n_a_n_o1_x2___definitions.html#gac3544758fe7062fa3b3246b1ae15f60b">CLK_PWRCTL_HIRC_FSEL_Msk</a></div><div class="ttdeci">#define CLK_PWRCTL_HIRC_FSEL_Msk</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d91/_nano1_x2_series_8h_source.html#l01469">Nano1X2Series.h:1469</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___definitions_html_gadf08d4f34c90e9b1ed984a2d0594f42c"><div class="ttname"><a href="../../da/d80/group___n_a_n_o1_x2___definitions.html#gadf08d4f34c90e9b1ed984a2d0594f42c">CLK_CLKSEL1_TMR0_S_Msk</a></div><div class="ttdeci">#define CLK_CLKSEL1_TMR0_S_Msk</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d91/_nano1_x2_series_8h_source.html#l01583">Nano1X2Series.h:1583</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___definitions_html_gaf7e17748e92034d8547e952c3ccc063a"><div class="ttname"><a href="../../da/d80/group___n_a_n_o1_x2___definitions.html#gaf7e17748e92034d8547e952c3ccc063a">CLK_CLKDIV1_TMR3_N_Msk</a></div><div class="ttdeci">#define CLK_CLKDIV1_TMR3_N_Msk</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d91/_nano1_x2_series_8h_source.html#l01640">Nano1X2Series.h:1640</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___definitions_html_gafcc261b9c98e0da4930bca8f7c20c88f"><div class="ttname"><a href="../../da/d80/group___n_a_n_o1_x2___definitions.html#gafcc261b9c98e0da4930bca8f7c20c88f">CLK_CLKSEL1_TMR1_S_Pos</a></div><div class="ttdeci">#define CLK_CLKSEL1_TMR1_S_Pos</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d91/_nano1_x2_series_8h_source.html#l01585">Nano1X2Series.h:1585</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___p_e_r_i_p_h_e_r_a_l___d_e_c_l_a_r_a_t_i_o_n_html_ga4b355291fe6b8ba8e167ab0faa862e45"><div class="ttname"><a href="../../da/d2d/group___n_a_n_o1_x2___p_e_r_i_p_h_e_r_a_l___d_e_c_l_a_r_a_t_i_o_n.html#ga4b355291fe6b8ba8e167ab0faa862e45">CLK</a></div><div class="ttdeci">#define CLK</div><div class="ttdoc">Pointer to CLK register structure.</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d91/_nano1_x2_series_8h_source.html#l10651">Nano1X2Series.h:10651</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___p_e_r_i_p_h_e_r_a_l___d_e_c_l_a_r_a_t_i_o_n_html_ga63bf4f24c85f26e838f55701a5e69831"><div class="ttname"><a href="../../da/d2d/group___n_a_n_o1_x2___p_e_r_i_p_h_e_r_a_l___d_e_c_l_a_r_a_t_i_o_n.html#ga63bf4f24c85f26e838f55701a5e69831">TIMER1</a></div><div class="ttdeci">#define TIMER1</div><div class="ttdoc">Pointer to TIMER1 register structure.</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d91/_nano1_x2_series_8h_source.html#l10634">Nano1X2Series.h:10634</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___p_e_r_i_p_h_e_r_a_l___d_e_c_l_a_r_a_t_i_o_n_html_ga6d4063b72c434f0e7afa8eb2a0e7ee00"><div class="ttname"><a href="../../da/d2d/group___n_a_n_o1_x2___p_e_r_i_p_h_e_r_a_l___d_e_c_l_a_r_a_t_i_o_n.html#ga6d4063b72c434f0e7afa8eb2a0e7ee00">TIMER3</a></div><div class="ttdeci">#define TIMER3</div><div class="ttdoc">Pointer to TIMER3 register structure.</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d91/_nano1_x2_series_8h_source.html#l10636">Nano1X2Series.h:10636</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___p_e_r_i_p_h_e_r_a_l___d_e_c_l_a_r_a_t_i_o_n_html_gaca904d0e4ebb6d643c349f7f05613995"><div class="ttname"><a href="../../da/d2d/group___n_a_n_o1_x2___p_e_r_i_p_h_e_r_a_l___d_e_c_l_a_r_a_t_i_o_n.html#gaca904d0e4ebb6d643c349f7f05613995">TIMER2</a></div><div class="ttdeci">#define TIMER2</div><div class="ttdoc">Pointer to TIMER2 register structure.</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d91/_nano1_x2_series_8h_source.html#l10635">Nano1X2Series.h:10635</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___p_e_r_i_p_h_e_r_a_l___d_e_c_l_a_r_a_t_i_o_n_html_gaf1b746ba5ab7d0ab657156ebda0f290c"><div class="ttname"><a href="../../da/d2d/group___n_a_n_o1_x2___p_e_r_i_p_h_e_r_a_l___d_e_c_l_a_r_a_t_i_o_n.html#gaf1b746ba5ab7d0ab657156ebda0f290c">TIMER0</a></div><div class="ttdeci">#define TIMER0</div><div class="ttdoc">Pointer to TIMER0 register structure.</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d91/_nano1_x2_series_8h_source.html#l10633">Nano1X2Series.h:10633</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___t_i_m_e_r___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s_html_ga0d86a240e96da7b8db2c11f4bbb46693"><div class="ttname"><a href="../../d4/d07/group___n_a_n_o1_x2___t_i_m_e_r___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga0d86a240e96da7b8db2c11f4bbb46693">TIMER_SetTriggerSource</a></div><div class="ttdeci">void TIMER_SetTriggerSource(TIMER_T *timer, uint32_t u32Src)</div><div class="ttdoc">This function is used to select the interrupt source used to trigger other modules.</div><div class="ttdef"><b>Definition:</b> <a href="../../df/d41/timer_8c_source.html#l00304">timer.c:304</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___t_i_m_e_r___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s_html_ga0dad1dbaf69f945c3d0d5aa91c4eef86"><div class="ttname"><a href="../../d4/d07/group___n_a_n_o1_x2___t_i_m_e_r___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga0dad1dbaf69f945c3d0d5aa91c4eef86">TIMER_Delay</a></div><div class="ttdeci">void TIMER_Delay(TIMER_T *timer, uint32_t u32Usec)</div><div class="ttdoc">This API is used to create a delay loop for u32usec micro seconds.</div><div class="ttdef"><b>Definition:</b> <a href="../../df/d41/timer_8c_source.html#l00088">timer.c:88</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___t_i_m_e_r___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s_html_ga1de0e4c2c84476d6c39d40a3bcaac18a"><div class="ttname"><a href="../../d4/d07/group___n_a_n_o1_x2___t_i_m_e_r___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga1de0e4c2c84476d6c39d40a3bcaac18a">TIMER_DisableCapture</a></div><div class="ttdeci">void TIMER_DisableCapture(TIMER_T *timer)</div><div class="ttdoc">This API is used to disable the Timer capture function.</div><div class="ttdef"><b>Definition:</b> <a href="../../df/d41/timer_8c_source.html#l00160">timer.c:160</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___t_i_m_e_r___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s_html_ga234d45c63fb6f5e977dbef2294089621"><div class="ttname"><a href="../../d4/d07/group___n_a_n_o1_x2___t_i_m_e_r___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga234d45c63fb6f5e977dbef2294089621">TIMER_Open</a></div><div class="ttdeci">uint32_t TIMER_Open(TIMER_T *timer, uint32_t u32Mode, uint32_t u32Freq)</div><div class="ttdoc">This API is used to configure timer to operate in specified mode and frequency. If timer cannot work ...</div><div class="ttdef"><b>Definition:</b> <a href="../../df/d41/timer_8c_source.html#l00042">timer.c:42</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___t_i_m_e_r___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s_html_ga4460ba2e5f3bdddafab005e1e1fda0da"><div class="ttname"><a href="../../d4/d07/group___n_a_n_o1_x2___t_i_m_e_r___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga4460ba2e5f3bdddafab005e1e1fda0da">TIMER_DisableEventCounter</a></div><div class="ttdeci">void TIMER_DisableEventCounter(TIMER_T *timer)</div><div class="ttdoc">This API is used to disable the Timer event counter function.</div><div class="ttdef"><b>Definition:</b> <a href="../../df/d41/timer_8c_source.html#l00186">timer.c:186</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___t_i_m_e_r___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s_html_ga452e6b15e2da57f1bb4432e01831c818"><div class="ttname"><a href="../../d4/d07/group___n_a_n_o1_x2___t_i_m_e_r___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga452e6b15e2da57f1bb4432e01831c818">TIMER_ResetCounter</a></div><div class="ttdeci">void TIMER_ResetCounter(TIMER_T *timer)</div><div class="ttdoc">This function is used to reset the Timer counter value.</div><div class="ttdef"><b>Definition:</b> <a href="../../df/d41/timer_8c_source.html#l00241">timer.c:241</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___t_i_m_e_r___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s_html_ga56facc5683886f3ff3b273a3b5e47fcd"><div class="ttname"><a href="../../d4/d07/group___n_a_n_o1_x2___t_i_m_e_r___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga56facc5683886f3ff3b273a3b5e47fcd">TIMER_GetModuleClock</a></div><div class="ttdeci">uint32_t TIMER_GetModuleClock(TIMER_T *timer)</div><div class="ttdoc">This API is used to get the clock frequency of Timer.</div><div class="ttdef"><b>Definition:</b> <a href="../../df/d41/timer_8c_source.html#l00197">timer.c:197</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___t_i_m_e_r___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s_html_ga709e58fa2804ed056f2e77f4b26cf686"><div class="ttname"><a href="../../d4/d07/group___n_a_n_o1_x2___t_i_m_e_r___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga709e58fa2804ed056f2e77f4b26cf686">TIMER_DisableFreqCounter</a></div><div class="ttdeci">void TIMER_DisableFreqCounter(TIMER_T *timer)</div><div class="ttdoc">This function is used to disable the Timer frequency counter function.</div><div class="ttdef"><b>Definition:</b> <a href="../../df/d41/timer_8c_source.html#l00291">timer.c:291</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___t_i_m_e_r___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s_html_ga72fc8741562dbff619aa7dfe8b73c0a7"><div class="ttname"><a href="../../d4/d07/group___n_a_n_o1_x2___t_i_m_e_r___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga72fc8741562dbff619aa7dfe8b73c0a7">TIMER_EnableEventCounter</a></div><div class="ttdeci">void TIMER_EnableEventCounter(TIMER_T *timer, uint32_t u32Edge)</div><div class="ttdoc">This function is used to enable the Timer counter function with specify detection edge.</div><div class="ttdef"><b>Definition:</b> <a href="../../df/d41/timer_8c_source.html#l00175">timer.c:175</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___t_i_m_e_r___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s_html_ga80ba64bdc40d36cb4a2139f4651b1c42"><div class="ttname"><a href="../../d4/d07/group___n_a_n_o1_x2___t_i_m_e_r___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga80ba64bdc40d36cb4a2139f4651b1c42">TIMER_EnableCapture</a></div><div class="ttdeci">void TIMER_EnableCapture(TIMER_T *timer, uint32_t u32CapMode, uint32_t u32Edge)</div><div class="ttdoc">This API is used to enable timer capture function with specified mode and capture edge.</div><div class="ttdef"><b>Definition:</b> <a href="../../df/d41/timer_8c_source.html#l00146">timer.c:146</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___t_i_m_e_r___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s_html_ga83113a85eb313523f4ec35ab585d8968"><div class="ttname"><a href="../../d4/d07/group___n_a_n_o1_x2___t_i_m_e_r___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga83113a85eb313523f4ec35ab585d8968">TIMER_Close</a></div><div class="ttdeci">void TIMER_Close(TIMER_T *timer)</div><div class="ttdoc">This API stops Timer counting and disable the Timer interrupt function.</div><div class="ttdef"><b>Definition:</b> <a href="../../df/d41/timer_8c_source.html#l00074">timer.c:74</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___t_i_m_e_r___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s_html_gaa01b131e6bd3d6c51662670377d32c97"><div class="ttname"><a href="../../d4/d07/group___n_a_n_o1_x2___t_i_m_e_r___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#gaa01b131e6bd3d6c51662670377d32c97">TIMER_SetTriggerTarget</a></div><div class="ttdeci">void TIMER_SetTriggerTarget(TIMER_T *timer, uint32_t u32Mask)</div><div class="ttdoc">This function is used to set modules trigger by timer interrupt.</div><div class="ttdef"><b>Definition:</b> <a href="../../df/d41/timer_8c_source.html#l00317">timer.c:317</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___t_i_m_e_r___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s_html_gaaf424bb31a227f8d672f337e5c6a6059"><div class="ttname"><a href="../../d4/d07/group___n_a_n_o1_x2___t_i_m_e_r___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#gaaf424bb31a227f8d672f337e5c6a6059">TIMER_EnableFreqCounter</a></div><div class="ttdeci">void TIMER_EnableFreqCounter(TIMER_T *timer, uint32_t u32DropCount, uint32_t u32Timeout, uint32_t u32EnableInt)</div><div class="ttdoc">This function is used to enable the Timer frequency counter function.</div><div class="ttdef"><b>Definition:</b> <a href="../../df/d41/timer_8c_source.html#l00264">timer.c:264</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2__legacy___constants_html_ga1b93de0ad6cd08676926bcff6888c10d"><div class="ttname"><a href="../../d4/d75/group___n_a_n_o1_x2__legacy___constants.html#ga1b93de0ad6cd08676926bcff6888c10d">TIMER_T::IER</a></div><div class="ttdeci">__IO uint32_t IER</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d91/_nano1_x2_series_8h_source.html#l09226">Nano1X2Series.h:9226</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2__legacy___constants_html_ga6a66d55fb7d20c3e12402aa320661d8f"><div class="ttname"><a href="../../d4/d75/group___n_a_n_o1_x2__legacy___constants.html#ga6a66d55fb7d20c3e12402aa320661d8f">TIMER_T::PRECNT</a></div><div class="ttdeci">__IO uint32_t PRECNT</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d91/_nano1_x2_series_8h_source.html#l09191">Nano1X2Series.h:9191</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2__legacy___constants_html_ga7f5ea6a1af3b26e732ffec08d4d519f5"><div class="ttname"><a href="../../d4/d75/group___n_a_n_o1_x2__legacy___constants.html#ga7f5ea6a1af3b26e732ffec08d4d519f5">TIMER_T::DR</a></div><div class="ttdeci">__IO uint32_t DR</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d91/_nano1_x2_series_8h_source.html#l09287">Nano1X2Series.h:9287</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2__legacy___constants_html_ga91eb63011da0934d7d8edcfb58566417"><div class="ttname"><a href="../../d4/d75/group___n_a_n_o1_x2__legacy___constants.html#ga91eb63011da0934d7d8edcfb58566417">TIMER_T::CMPR</a></div><div class="ttdeci">__IO uint32_t CMPR</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d91/_nano1_x2_series_8h_source.html#l09208">Nano1X2Series.h:9208</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2__legacy___constants_html_gabb8d9df4695b742a04b52a7a64594322"><div class="ttname"><a href="../../d4/d75/group___n_a_n_o1_x2__legacy___constants.html#gabb8d9df4695b742a04b52a7a64594322">TIMER_T::CTL</a></div><div class="ttdeci">__IO uint32_t CTL</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d91/_nano1_x2_series_8h_source.html#l09178">Nano1X2Series.h:9178</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2__legacy___constants_html_gaf6e91877db4ad3b35116bbd1c281bda6"><div class="ttname"><a href="../../d4/d75/group___n_a_n_o1_x2__legacy___constants.html#gaf6e91877db4ad3b35116bbd1c281bda6">TIMER_T::ECTL</a></div><div class="ttdeci">__IO uint32_t ECTL</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d91/_nano1_x2_series_8h_source.html#l09343">Nano1X2Series.h:9343</a></div></div>
<div class="ttc" id="astruct_t_i_m_e_r___t_html"><div class="ttname"><a href="../../d9/d66/struct_t_i_m_e_r___t.html">TIMER_T</a></div><div class="ttdef"><b>Definition:</b> <a href="../../da/d91/_nano1_x2_series_8h_source.html#l09027">Nano1X2Series.h:9028</a></div></div>
<div class="ttc" id="asystem___nano1_x2_series_8h_html_a37c1644396b5996e92902bbf2dfc3ec5"><div class="ttname"><a href="../../d9/dd8/system___nano1_x2_series_8h.html#a37c1644396b5996e92902bbf2dfc3ec5">__HXT</a></div><div class="ttdeci">#define __HXT</div><div class="ttdef"><b>Definition:</b> <a href="../../d9/dd8/system___nano1_x2_series_8h_source.html#l00026">system_Nano1X2Series.h:26</a></div></div>
<div class="ttc" id="asystem___nano1_x2_series_8h_html_a6f446dd2f087f409b4fc986c0c25c2a9"><div class="ttname"><a href="../../d9/dd8/system___nano1_x2_series_8h.html#a6f446dd2f087f409b4fc986c0c25c2a9">__LIRC</a></div><div class="ttdeci">#define __LIRC</div><div class="ttdef"><b>Definition:</b> <a href="../../d9/dd8/system___nano1_x2_series_8h_source.html#l00030">system_Nano1X2Series.h:30</a></div></div>
<div class="ttc" id="asystem___nano1_x2_series_8h_html_aa3cd3e43291e81e795d642b79b6088e6"><div class="ttname"><a href="../../d9/dd8/system___nano1_x2_series_8h.html#aa3cd3e43291e81e795d642b79b6088e6">SystemCoreClock</a></div><div class="ttdeci">uint32_t SystemCoreClock</div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d7e/system___nano1_x2_series_8c_source.html#l00020">system_Nano1X2Series.c:20</a></div></div>
<div class="ttc" id="asystem___nano1_x2_series_8h_html_aae5c5ec4722a291e1271743d45414223"><div class="ttname"><a href="../../d9/dd8/system___nano1_x2_series_8h.html#aae5c5ec4722a291e1271743d45414223">__HIRC16M</a></div><div class="ttdeci">#define __HIRC16M</div><div class="ttdef"><b>Definition:</b> <a href="../../d9/dd8/system___nano1_x2_series_8h_source.html#l00029">system_Nano1X2Series.h:29</a></div></div>
<div class="ttc" id="asystem___nano1_x2_series_8h_html_ab781074cbf310ee17748083dbe36ae98"><div class="ttname"><a href="../../d9/dd8/system___nano1_x2_series_8h.html#ab781074cbf310ee17748083dbe36ae98">__LXT</a></div><div class="ttdeci">#define __LXT</div><div class="ttdef"><b>Definition:</b> <a href="../../d9/dd8/system___nano1_x2_series_8h_source.html#l00027">system_Nano1X2Series.h:27</a></div></div>
<div class="ttc" id="asystem___nano1_x2_series_8h_html_ad145c32431f633b887d84ef0c78f42f3"><div class="ttname"><a href="../../d9/dd8/system___nano1_x2_series_8h.html#ad145c32431f633b887d84ef0c78f42f3">__HIRC12M</a></div><div class="ttdeci">#define __HIRC12M</div><div class="ttdef"><b>Definition:</b> <a href="../../d9/dd8/system___nano1_x2_series_8h_source.html#l00028">system_Nano1X2Series.h:28</a></div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Fri Oct 18 2024 12:20:31 for NANO102/112 BSP by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="../../doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.3
</small></address>
</body>
</html>
